diff --git a/contrib/gmm/gmm_vector.h b/contrib/gmm/gmm_vector.h
index f114a32aab..2e4919bf73 100644
--- a/contrib/gmm/gmm_vector.h
+++ b/contrib/gmm/gmm_vector.h
@@ -170,14 +708,14 @@ namespace gmm {
     // typedef size_t              size_type;
     typedef ptrdiff_t           difference_type;
     typedef std::bidirectional_iterator_tag iterator_category;
-    
+
     reference operator *() const { return (base_it_type::operator*()).second; }
     pointer operator->() const { return &(operator*()); }
-    size_type index(void) const { return (base_it_type::operator*()).first; }
+    size_type index() const { return (base_it_type::operator*()).first; }
 
-    wsvector_const_iterator(void) {}
+    wsvector_const_iterator() {}
     wsvector_const_iterator(const wsvector_iterator<T> &it)
-      : base_it_type(it) {}
+      : base_it_type(typename std::map<size_type, T>::iterator(it)) {}
     wsvector_const_iterator(const base_it_type &it) : base_it_type(it) {}
   };
 
@@ -188,7 +726,7 @@ namespace gmm {
   */
   template<typename T> class wsvector : public std::map<size_type, T> {
   public:
-    
+
     typedef typename std::map<int, T>::size_type size_type;
     typedef std::map<size_type, T> base_type;
     typedef typename base_type::iterator iterator;
@@ -196,20 +734,29 @@ namespace gmm {
 
   protected:
     size_type nbl;
-    
+
   public:
     void clean(double eps);
     void resize(size_type);
-    
+
     inline ref_elt_vector<T, wsvector<T> > operator [](size_type c)
     { return ref_elt_vector<T, wsvector<T> >(this, c); }
 
     inline void w(size_type c, const T &e) {
       GMM_ASSERT2(c < nbl, "out of range");
-      if (e == T(0)) { base_type::erase(c); }
+      if (e == T(0)) { this->erase(c); }
       else base_type::operator [](c) = e;
     }
 
+    inline void wa(size_type c, const T &e) {
+      GMM_ASSERT2(c < nbl, "out of range");
+      if (e != T(0)) {
+        iterator it = this->lower_bound(c);
+        if (it != this->end() && it->first == c) it->second += e;
+        else base_type::operator [](c) = e;
+      }
+    }
+
     inline T r(size_type c) const {
       GMM_ASSERT2(c < nbl, "out of range");
       const_iterator it = this->lower_bound(c);
@@ -218,31 +765,31 @@ namespace gmm {
     }
 
     inline T operator [](size_type c) const { return r(c); }
-    
-    size_type nb_stored(void) const { return base_type::size(); }
-    size_type size(void) const { return nbl; }
+
+    size_type nb_stored() const { return base_type::size(); }
+    size_type size() const { return nbl; }
 
     void swap(wsvector<T> &v)
     { std::swap(nbl, v.nbl); std::map<size_type, T>::swap(v); }
-				       
 
-    /* Constructeurs */
+
+    /* Constructors */
     void init(size_type l) { nbl = l; this->clear(); }
     explicit wsvector(size_type l){ init(l); }
-    wsvector(void) { init(0); }
+    wsvector() { init(0); }
   };
 
   template<typename T>  void wsvector<T>::clean(double eps) {
     iterator it = this->begin(), itf = it, ite = this->end();
     while (it != ite) {
-      ++itf; if (gmm::abs(it->second) <= eps) erase(it); it = itf;
+      ++itf; if (gmm::abs(it->second) <= eps) this->erase(it); it = itf;
     }
   }
 
   template<typename T>  void wsvector<T>::resize(size_type n) {
     if (n < nbl) {
       iterator it = this->begin(), itf = it, ite = this->end();
-      while (it != ite) { ++itf; if (it->first >= n) erase(it); it = itf; }
+      while (it != ite) { ++itf; if (it->first >= n) this->erase(it); it=itf; }
     }
     nbl = n;
   }
@@ -269,10 +816,10 @@ namespace gmm {
     { o->clear(); }
     static void do_clear(this_type &v) { v.clear(); }
     static value_type access(const origin_type *o, const const_iterator &,
-			     const const_iterator &, size_type i)
+                             const const_iterator &, size_type i)
     { return (*o)[i]; }
     static reference access(origin_type *o, const iterator &, const iterator &,
-			    size_type i)
+                            size_type i)
     { return (*o)[i]; }
     static void resize(this_type &v, size_type n) { v.resize(n); }
   };
@@ -283,7 +830,7 @@ namespace gmm {
   /******* Optimized BLAS for wsvector<T> **********************************/
 
   template <typename T> inline void copy(const wsvector<T> &v1,
-					 wsvector<T> &v2) {
+                                         wsvector<T> &v2) {
     GMM_ASSERT2(vect_size(v1) == vect_size(v2), "dimensions mismatch");
     v2 = v1;
   }
@@ -298,7 +845,7 @@ namespace gmm {
   }
   template <typename T> inline
   void copy(const simple_vector_ref<const wsvector<T> *> &v1,
-	    wsvector<T> &v2)
+            wsvector<T> &v2)
   { copy(*(v1.origin), v2); }
   template <typename T> inline
   void copy(const simple_vector_ref<wsvector<T> *> &v1, wsvector<T> &v2)
@@ -307,9 +854,9 @@ namespace gmm {
   template <typename T> inline void clean(wsvector<T> &v, double eps) {
     typedef typename number_traits<T>::magnitude_type R;
     typename wsvector<T>::iterator it = v.begin(), ite = v.end(), itc;
-    while (it != ite) 
+    while (it != ite)
       if (gmm::abs((*it).second) <= R(eps))
-	{ itc=it; ++it; v.erase(itc); } else ++it; 
+        { itc=it; ++it; v.erase(itc); } else ++it;
   }
 
   template <typename T>
@@ -333,9 +880,9 @@ namespace gmm {
 
   template<typename T> struct elt_rsvector_ {
     size_type c; T e;
-    /* e is initialized by default to avoid some false warnings of valgrind..
+    /* e is initialized by default to avoid some false warnings of valgrind.
        (from http://valgrind.org/docs/manual/mc-manual.html:
-      
+
        When memory is read into the CPU's floating point registers, the
        relevant V bits are read from memory and they are immediately
        checked. If any are invalid, an uninitialised value error is
@@ -344,7 +891,7 @@ namespace gmm {
        does not have to track the validity status of the floating-point
        registers.
     */
-    elt_rsvector_(void) : e(0) {}
+    elt_rsvector_() : e(0) {}
     elt_rsvector_(size_type cc) : c(cc), e(0) {}
     elt_rsvector_(size_type cc, const T &ee) : c(cc), e(ee) {}
     bool operator < (const elt_rsvector_ &a) const { return c < a.c; }
@@ -375,8 +922,8 @@ namespace gmm {
     bool operator ==(const iterator &i) const { return it == i.it; }
     bool operator !=(const iterator &i) const { return !(i == *this); }
 
-    size_type index(void) const { return it->c; }
-    rsvector_iterator(void) {}
+    size_type index() const { return it->c; }
+    rsvector_iterator() {}
     rsvector_iterator(const IT &i) : it(i) {}
   };
 
@@ -394,7 +941,7 @@ namespace gmm {
 
     reference operator *() const { return it->e; }
     pointer operator->() const { return &(operator*()); }
-    size_type index(void) const { return it->c; }
+    size_type index() const { return it->c; }
 
     iterator &operator ++() { ++it; return *this; }
     iterator operator ++(int) { iterator tmp = *this; ++(*this); return tmp; }
@@ -404,18 +951,18 @@ namespace gmm {
     bool operator ==(const iterator &i) const { return it == i.it; }
     bool operator !=(const iterator &i) const { return !(i == *this); }
 
-    rsvector_const_iterator(void) {}
+    rsvector_const_iterator() {}
     rsvector_const_iterator(const rsvector_iterator<T> &i) : it(i.it) {}
     rsvector_const_iterator(const IT &i) : it(i) {}
   };
 
   /**
      sparse vector built upon std::vector. Read access is fast,
-     but insertion is O(n) 
+     but insertion is O(n)
   */
   template<typename T> class rsvector : public std::vector<elt_rsvector_<T> > {
   public:
-    
+
     typedef std::vector<elt_rsvector_<T> > base_type_;
     typedef typename base_type_::iterator iterator;
     typedef typename base_type_::const_iterator const_iterator;
@@ -423,32 +970,33 @@ namespace gmm {
     typedef T value_type;
 
   protected:
-    size_type nbl;    	/* size of the vector.	          	  */
-    
+    size_type nbl;    // size of the vector
+
   public:
 
     void sup(size_type j);
     void base_resize(size_type n) { base_type_::resize(n); }
     void resize(size_type);
-    
+
     ref_elt_vector<T, rsvector<T> > operator [](size_type c)
     { return ref_elt_vector<T, rsvector<T> >(this, c); }
 
     void w(size_type c, const T &e);
+    void wa(size_type c, const T &e);
     T r(size_type c) const;
     void swap_indices(size_type i, size_type j);
 
     inline T operator [](size_type c) const { return r(c); }
-    
-    size_type nb_stored(void) const { return base_type_::size(); }
-    size_type size(void) const { return nbl; }
-    void clear(void) { base_type_::resize(0); }
+
+    size_type nb_stored() const { return base_type_::size(); }
+    size_type size() const { return nbl; }
+    void clear() { base_type_::resize(0); }
     void swap(rsvector<T> &v)
     { std::swap(nbl, v.nbl); std::vector<elt_rsvector_<T> >::swap(v); }
 
     /* Constructeurs */
     explicit rsvector(size_type l) : nbl(l) { }
-    rsvector(void) : nbl(0) { }
+    rsvector() : nbl(0) { }
   };
 
   template <typename T>
@@ -465,18 +1013,18 @@ namespace gmm {
 
       switch (situation) {
       case 1 : a = *iti; a.c = j; it = iti; ++it; ite = this->end();
-	       for (; it != ite && it->c <= j; ++it, ++iti) *iti = *it;
-	       *iti = a;
-	       break;
+               for (; it != ite && it->c <= j; ++it, ++iti) *iti = *it;
+               *iti = a;
+               break;
       case 2 : a = *itj; a.c = i; it = itj; ite = this->begin();
-	if (it != ite) {
-	  --it;
-	  while (it->c >= i) { *itj = *it;  --itj; if (it==ite) break; --it; }
-	}
-	*itj = a;
-	break;
+        if (it != ite) {
+          --it;
+          while (it->c >= i) { *itj = *it;  --itj; if (it==ite) break; --it; }
+        }
+        *itj = a;
+        break;
       case 3 : std::swap(iti->e, itj->e);
-	       break;
+               break;
       }
     }
   }
@@ -486,8 +1034,8 @@ namespace gmm {
       elt_rsvector_<T> ev(j);
       iterator it = std::lower_bound(this->begin(), this->end(), ev);
       if (it != this->end() && it->c == j) {
-	for (iterator ite = this->end() - 1; it != ite; ++it) *it = *(it+1);
-	base_type_::resize(nb_stored()-1);
+        for (iterator ite = this->end() - 1; it != ite; ++it) *it = *(it+1);
+        base_resize(nb_stored()-1);
       }
     }
   }
@@ -495,7 +1043,7 @@ namespace gmm {
   template<typename T>  void rsvector<T>::resize(size_type n) {
     if (n < nbl) {
       for (size_type i = 0; i < nb_stored(); ++i)
-	if (base_type_::operator[](i).c >= n) { base_resize(i); break; }
+        if (base_type_::operator[](i).c >= n) { base_resize(i); break; }
     }
     nbl = n;
   }
@@ -506,27 +1054,58 @@ namespace gmm {
     else {
       elt_rsvector_<T> ev(c, e);
       if (nb_stored() == 0) {
-	base_type_::resize(1,ev);
+        base_type_::push_back(ev);
       }
       else {
-	iterator it = std::lower_bound(this->begin(), this->end(), ev);
-	if (it != this->end() && it->c == c) it->e = e;
-	else {
-	  size_type ind = it - this->begin();
-	  base_type_::resize(nb_stored()+1, ev);
-	  if (ind != nb_stored() - 1) {
-	    it = this->begin() + ind;
-	    for (iterator ite = this->end() - 1; ite != it; --ite)
-	      *ite = *(ite-1);
-	    *it = ev;
-	  }
-	}
+        iterator it = std::lower_bound(this->begin(), this->end(), ev);
+        if (it != this->end() && it->c == c) it->e = e;
+        else {
+          size_type ind = it - this->begin(), nb = this->nb_stored();
+          if (nb - ind > 1100)
+            GMM_WARNING2("Inefficient addition of element in rsvector with "
+                         << this->nb_stored() - ind << " non-zero entries");
+          base_type_::push_back(ev);
+          if (ind != nb) {
+            it = this->begin() + ind;
+            iterator ite = this->end(); --ite; iterator itee = ite;
+            for (; ite != it; --ite) { --itee; *ite = *itee; }
+            *it = ev;
+          }
+        }
       }
     }
   }
-  
-  template <typename T> T rsvector<T>::r(size_type c) const {
+
+  template <typename T> void rsvector<T>::wa(size_type c, const T &e) {
     GMM_ASSERT2(c < nbl, "out of range");
+    if (e != T(0)) {
+      elt_rsvector_<T> ev(c, e);
+      if (nb_stored() == 0) {
+        base_type_::push_back(ev);
+      }
+      else {
+        iterator it = std::lower_bound(this->begin(), this->end(), ev);
+        if (it != this->end() && it->c == c) it->e += e;
+        else {
+          size_type ind = it - this->begin(), nb = this->nb_stored();
+          if (nb - ind > 1100)
+            GMM_WARNING2("Inefficient addition of element in rsvector with "
+                         << this->nb_stored() - ind << " non-zero entries");
+          base_type_::push_back(ev);
+          if (ind != nb) {
+            it = this->begin() + ind;
+            iterator ite = this->end(); --ite; iterator itee = ite;
+            for (; ite != it; --ite) { --itee; *ite = *itee; }
+            *it = ev;
+          }
+        }
+      }
+    }
+  }
+
+  template <typename T> T rsvector<T>::r(size_type c) const {
+    GMM_ASSERT2(c < nbl, "out of range. Index " << c
+                << " for a length of " << nbl);
     if (nb_stored() != 0) {
       elt_rsvector_<T> ev(c);
       const_iterator it = std::lower_bound(this->begin(), this->end(), ev);
@@ -559,10 +1138,10 @@ namespace gmm {
     { o->clear(); }
     static void do_clear(this_type &v) { v.clear(); }
     static value_type access(const origin_type *o, const const_iterator &,
-			     const const_iterator &, size_type i)
+                             const const_iterator &, size_type i)
     { return (*o)[i]; }
     static reference access(origin_type *o, const iterator &, const iterator &,
-			    size_type i)
+                            size_type i)
     { return (*o)[i]; }
     static void resize(this_type &v, size_type n) { v.resize(n); }
   };
@@ -573,7 +1152,7 @@ namespace gmm {
   /******* Optimized operations for rsvector<T> ****************************/
 
   template <typename T> inline void copy(const rsvector<T> &v1,
- 					 rsvector<T> &v2) {
+                                          rsvector<T> &v2) {
     GMM_ASSERT2(vect_size(v1) == vect_size(v2), "dimensions mismatch");
     v2 = v1;
   }
@@ -588,39 +1167,39 @@ namespace gmm {
   }
   template <typename T> inline
   void copy(const simple_vector_ref<const rsvector<T> *> &v1,
-	    rsvector<T> &v2)
+            rsvector<T> &v2)
   { copy(*(v1.origin), v2); }
   template <typename T> inline
   void copy(const simple_vector_ref<rsvector<T> *> &v1, rsvector<T> &v2)
   { copy(*(v1.origin), v2); }
 
   template <typename V, typename T> inline void add(const V &v1,
-						    rsvector<T> &v2) {
+                                                    rsvector<T> &v2) {
     if ((const void *)(&v1) != (const void *)(&v2)) {
       GMM_ASSERT2(vect_size(v1) == vect_size(v2), "dimensions mismatch");
-	add_rsvector(v1, v2, typename linalg_traits<V>::storage_type());
+        add_rsvector(v1, v2, typename linalg_traits<V>::storage_type());
     }
   }
 
-  template <typename V, typename T> 
+  template <typename V, typename T>
   inline void add_rsvector(const V &v1, rsvector<T> &v2, abstract_dense)
   { add(v1, v2, abstract_dense(), abstract_sparse()); }
 
-  template <typename V, typename T> 
+  template <typename V, typename T>
   inline void add_rsvector(const V &v1, rsvector<T> &v2, abstract_skyline)
   { add(v1, v2, abstract_skyline(), abstract_sparse()); }
 
-  template <typename V, typename T> 
+  template <typename V, typename T>
   void add_rsvector(const V &v1, rsvector<T> &v2, abstract_sparse) {
     add_rsvector(v1, v2, typename linalg_traits<V>::index_sorted());
   }
 
-  template <typename V, typename T> 
+  template <typename V, typename T>
   void add_rsvector(const V &v1, rsvector<T> &v2, linalg_false) {
     add(v1, v2, abstract_sparse(), abstract_sparse());
   }
 
-  template <typename V, typename T> 
+  template <typename V, typename T>
   void add_rsvector(const V &v1, rsvector<T> &v2, linalg_true) {
     typename linalg_traits<V>::const_iterator it1 = vect_const_begin(v1),
       ite1 = vect_const_end(v1);
@@ -634,31 +1213,49 @@ namespace gmm {
 
     v2.base_resize(nbc);
     it3 = v2.begin() + old_nbc;
-    it2 = v2.end(); ite2 = v2.begin();
-    it1 = vect_end(v1); ite1 = vect_const_begin(v1);
-    while (it1 != ite1 && it3 != ite2) {
-      --it3; --it1; --it2;
-      if (it3->c > it1.index()) { *it2 = *it3; ++it1; }
-      else if (it3->c == it1.index()) { *it2=*it3; it2->e+=*it1; }
-      else { it2->c = it1.index(); it2->e = *it1; ++it3; }
-    }
-    while (it1 != ite1) { --it1; --it2; it2->c = it1.index(); it2->e = *it1; }
+    it2 = v2.end();
+    ite2 = v2.begin();
+    it1 = vect_end(v1);
+    ite1 = vect_const_begin(v1);
+    while (it1 != ite1 && it2 != ite2 && it3 != ite2){
+      --it3;
+      --it1;
+      --it2;
+      if (it3->c > it1.index()) {
+        *it2 = *it3;
+        ++it1;
+      }
+      else if (it3->c == it1.index()) {
+        *it2=*it3;
+        it2->e+=*it1;
+      }
+      else {
+        it2->c = it1.index();
+        it2->e = *it1; ++it3;
+      }
+    }
+    while (it1 != ite1 && it2 != ite2) {
+      --it1;
+      --it2;
+      it2->c = it1.index();
+      it2->e = *it1;
+    }
   }
 
   template <typename V, typename T> void copy(const V &v1, rsvector<T> &v2) {
     if ((const void *)(&v1) != (const void *)(&v2)) {
       GMM_ASSERT2(vect_size(v1) == vect_size(v2), "dimensions mismatch");
       if (same_origin(v1, v2))
-	GMM_WARNING2("a conflict is possible in vector copy\n");
+        GMM_WARNING2("a conflict is possible in vector copy\n");
       copy_rsvector(v1, v2, typename linalg_traits<V>::storage_type());
     }
   }
 
-  template <typename V, typename T> 
+  template <typename V, typename T>
   void copy_rsvector(const V &v1, rsvector<T> &v2, abstract_dense)
   { copy_vect(v1, v2, abstract_dense(), abstract_sparse()); }
 
-  template <typename V, typename T> 
+  template <typename V, typename T>
   void copy_rsvector(const V &v1, rsvector<T> &v2, abstract_skyline)
   { copy_vect(v1, v2, abstract_skyline(), abstract_sparse()); }
 
@@ -666,7 +1263,7 @@ namespace gmm {
   void copy_rsvector(const V &v1, rsvector<T> &v2, abstract_sparse) {
     copy_rsvector(v1, v2, typename linalg_traits<V>::index_sorted());
   }
-  
+
   template <typename V, typename T2>
   void copy_rsvector(const V &v1, rsvector<T2> &v2, linalg_true) {
     typedef typename linalg_traits<V>::value_type T1;
@@ -693,7 +1290,7 @@ namespace gmm {
     v2.base_resize(nn);
     std::sort(v2.begin(), v2.end());
   }
-  
+
   template <typename T> inline void clean(rsvector<T> &v, double eps) {
     typedef typename number_traits<T>::magnitude_type R;
     typename rsvector<T>::iterator it = v.begin(), ite = v.end();
@@ -702,7 +1299,7 @@ namespace gmm {
       typename rsvector<T>::iterator itc = it;
       size_type erased = 1;
       for (++it; it != ite; ++it)
-	{ *itc = *it; if (gmm::abs((*it).e) <= R(eps)) ++erased; else ++itc; }
+        { *itc = *it; if (gmm::abs((*it).e) <= R(eps)) ++erased; else ++itc; }
       v.base_resize(v.nb_stored() - erased);
     }
   }
@@ -716,7 +1313,7 @@ namespace gmm {
     clean(*pv, eps);
     svr->begin_ = vect_begin(*pv); svr->end_ = vect_end(*pv);
   }
-  
+
   template <typename T>
   inline size_type nnz(const rsvector<T>& l) { return l.nb_stored(); }
 
@@ -738,8 +1335,8 @@ namespace gmm {
 
     base_iterator it;
     size_type shift;
-    
-   
+
+
     iterator &operator ++()
     { ++it; ++shift; return *this; }
     iterator &operator --()
@@ -758,21 +1355,21 @@ namespace gmm {
     { iterator tmp = *this; return (tmp -= i); }
     difference_type operator -(const iterator &i) const
     { return it - i.it; }
-	
+
     reference operator *() const
     { return *it; }
     reference operator [](int ii)
     { return *(it + ii); }
-    
+
     bool operator ==(const iterator &i) const
     { return it == i.it; }
     bool operator !=(const iterator &i) const
     { return !(i == *this); }
     bool operator < (const iterator &i) const
     { return it < i.it; }
-    size_type index(void) const { return shift; }
+    size_type index() const { return shift; }
 
-    slvector_iterator(void) {}
+    slvector_iterator() {}
     slvector_iterator(const base_iterator &iter, size_type s)
       : it(iter), shift(s) {}
   };
@@ -789,8 +1386,8 @@ namespace gmm {
 
     base_iterator it;
     size_type shift;
-    
-   
+
+
     iterator &operator ++()
     { ++it; ++shift; return *this; }
     iterator &operator --()
@@ -809,21 +1406,21 @@ namespace gmm {
     { iterator tmp = *this; return (tmp -= i); }
     difference_type operator -(const iterator &i) const
     { return it - i.it; }
-	
+
     value_type operator *() const
     { return *it; }
     value_type operator [](int ii)
     { return *(it + ii); }
-    
+
     bool operator ==(const iterator &i) const
     { return it == i.it; }
     bool operator !=(const iterator &i) const
     { return !(i == *this); }
     bool operator < (const iterator &i) const
     { return it < i.it; }
-    size_type index(void) const { return shift; }
+    size_type index() const { return shift; }
 
-    slvector_const_iterator(void) {}
+    slvector_const_iterator() {}
     slvector_const_iterator(const slvector_iterator<T>& iter)
       : it(iter.it), shift(iter.shift) {}
     slvector_const_iterator(const base_iterator &iter, size_type s)
@@ -834,7 +1431,7 @@ namespace gmm {
   /** skyline vector.
    */
   template <typename T> class slvector {
-    
+
   public :
     typedef slvector_iterator<T> iterators;
     typedef slvector_const_iterator<T> const_iterators;
@@ -849,20 +1446,21 @@ namespace gmm {
 
   public :
 
-    size_type size(void) const { return size_; }
-    size_type first(void) const { return shift; }
-    size_type last(void) const { return shift + data.size(); }
+    size_type size() const { return size_; }
+    size_type first() const { return shift; }
+    size_type last() const { return shift + data.size(); }
     ref_elt_vector<T, slvector<T> > operator [](size_type c)
     { return ref_elt_vector<T, slvector<T> >(this, c); }
 
-    typename std::vector<T>::iterator data_begin(void) { return data.begin(); }
-    typename std::vector<T>::iterator data_end(void) { return data.end(); }
-    typename std::vector<T>::const_iterator data_begin(void) const
+    typename std::vector<T>::iterator data_begin() { return data.begin(); }
+    typename std::vector<T>::iterator data_end() { return data.end(); }
+    typename std::vector<T>::const_iterator data_begin() const
       { return data.begin(); }
-    typename std::vector<T>::const_iterator data_end(void) const
+    typename std::vector<T>::const_iterator data_end() const
       { return data.end(); }
 
     void w(size_type c, const T &e);
+    void wa(size_type c, const T &e);
     T r(size_type c) const {
       GMM_ASSERT2(c < size_, "out of range");
       if (c < shift || c >= shift + data.size()) return T(0);
@@ -871,7 +1469,7 @@ namespace gmm {
 
     inline T operator [](size_type c) const { return r(c); }
     void resize(size_type);
-    void clear(void) { data.resize(0); shift = 0; }
+    void clear() { data.resize(0); shift = 0; }
     void swap(slvector<T> &v) {
       std::swap(data, v.data);
       std::swap(shift, v.shift);
@@ -879,7 +1477,7 @@ namespace gmm {
     }
 
 
-    slvector(void) : data(0), shift(0), size_(0) {}
+    slvector() : data(0), shift(0), size_(0) {}
     explicit slvector(size_type l) : data(0), shift(0), size_(l) {}
     slvector(size_type l, size_type d, size_type s)
       : data(d), shift(s), size_(l) {}
@@ -898,7 +1496,7 @@ namespace gmm {
     size_type s = data.size();
     if (!s) { data.resize(1); shift = c; }
     else if (c < shift) {
-      data.resize(s + shift - c); 
+      data.resize(s + shift - c);
       typename std::vector<T>::iterator it = data.begin(),it2=data.end()-1;
       typename std::vector<T>::iterator it3 = it2 - shift + c;
       for (; it3 >= it; --it3, --it2) *it2 = *it3;
@@ -906,12 +1504,36 @@ namespace gmm {
       shift = c;
     }
     else if (c >= shift + s) {
-      data.resize(c - shift + 1);
-      std::fill(data.begin() + s, data.end(), T(0));
+      data.resize(c - shift + 1, T(0));
+      // std::fill(data.begin() + s, data.end(), T(0));
     }
     data[c - shift] = e;
   }
-  
+
+  template<typename T>  void slvector<T>::wa(size_type c, const T &e) {
+    GMM_ASSERT2(c < size_, "out of range");
+    size_type s = data.size();
+    if (!s) { data.resize(1, e); shift = c; return; }
+    else if (c < shift) {
+      data.resize(s + shift - c);
+      typename std::vector<T>::iterator it = data.begin(),it2=data.end()-1;
+      typename std::vector<T>::iterator it3 = it2 - shift + c;
+      for (; it3 >= it; --it3, --it2) *it2 = *it3;
+      std::fill(it, it + shift - c, T(0));
+      shift = c;
+      data[c - shift] = e;
+      return;
+    }
+    else if (c >= shift + s) {
+      data.resize(c - shift + 1, T(0));
+      data[c - shift] = e;
+      return;
+      // std::fill(data.begin() + s, data.end(), T(0));
+    }
+    data[c - shift] += e;
+  }
+
+
   template <typename T> struct linalg_traits<slvector<T> > {
     typedef slvector<T> this_type;
     typedef this_type origin_type;
@@ -938,10 +1560,10 @@ namespace gmm {
     { o->clear(); }
     static void do_clear(this_type &v) { v.clear(); }
     static value_type access(const origin_type *o, const const_iterator &,
-			     const const_iterator &, size_type i)
+                             const const_iterator &, size_type i)
     { return (*o)[i]; }
     static reference access(origin_type *o, const iterator &, const iterator &,
-			    size_type i)
+                            size_type i)
     { return (*o)[i]; }
     static void resize(this_type &v, size_type n) { v.resize(n); }
   };
diff --git a/contrib/gmm/gmm_vector_to_matrix.h b/contrib/gmm/gmm_vector_to_matrix.h
index 50036fc639..95b0bea1f2 100644
--- a/contrib/gmm/gmm_vector_to_matrix.h
+++ b/contrib/gmm/gmm_vector_to_matrix.h
@@ -1,32 +1,33 @@
-// -*- c++ -*- (enables emacs c++ mode)
-//===========================================================================
-//
-// Copyright (C) 2003-2008 Yves Renard
-//
-// This file is a part of GETFEM++
-//
-// Getfem++  is  free software;  you  can  redistribute  it  and/or modify it
-// under  the  terms  of the  GNU  Lesser General Public License as published
-// by  the  Free Software Foundation;  either version 2.1 of the License,  or
-// (at your option) any later version.
-// This program  is  distributed  in  the  hope  that it will be useful,  but
-// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
-// or  FITNESS  FOR  A PARTICULAR PURPOSE.  See the GNU Lesser General Public
-// License for more details.
-// You  should  have received a copy of the GNU Lesser General Public License
-// along  with  this program;  if not, write to the Free Software Foundation,
-// Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA.
-//
-// As a special exception, you may use this file as part of a free software
-// library without restriction.  Specifically, if other files instantiate
-// templates or use macros or inline functions from this file, or you compile
-// this file and link it with other files to produce an executable, this
-// file does not by itself cause the resulting executable to be covered by
-// the GNU General Public License.  This exception does not however
-// invalidate any other reasons why the executable file might be covered by
-// the GNU General Public License.
-//
-//===========================================================================
+/* -*- c++ -*- (enables emacs c++ mode) */
+/*===========================================================================
+
+ Copyright (C) 2003-2020 Yves Renard
+
+ This file is a part of GetFEM
+
+ GetFEM  is  free software;  you  can  redistribute  it  and/or modify it
+ under  the  terms  of the  GNU  Lesser General Public License as published
+ by  the  Free Software Foundation;  either version 3 of the License,  or
+ (at your option) any later version along with the GCC Runtime Library
+ Exception either version 3.1 or (at your option) any later version.
+ This program  is  distributed  in  the  hope  that it will be useful,  but
+ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+ or  FITNESS  FOR  A PARTICULAR PURPOSE.  See the GNU Lesser General Public
+ License and GCC Runtime Library Exception for more details.
+ You  should  have received a copy of the GNU Lesser General Public License
+ along  with  this program;  if not, write to the Free Software Foundation,
+ Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA.
+
+ As a special exception, you  may use  this file  as it is a part of a free
+ software  library  without  restriction.  Specifically,  if   other  files
+ instantiate  templates  or  use macros or inline functions from this file,
+ or  you compile this  file  and  link  it  with other files  to produce an
+ executable, this file  does  not  by itself cause the resulting executable
+ to be covered  by the GNU Lesser General Public License.  This   exception
+ does not  however  invalidate  any  other  reasons why the executable file
+ might be covered by the GNU Lesser General Public License.
+
+===========================================================================*/
 
 /**@file gmm_vector_to_matrix.h
    @author  Yves Renard <Yves.Renard@insa-lyon.fr>
diff --git a/src/solver/linearSystemCSR.cpp b/src/solver/linearSystemCSR.cpp
index 486a8433ca..14dbadf2d5 100644
--- a/src/solver/linearSystemCSR.cpp
+++ b/src/solver/linearSystemCSR.cpp
@@ -437,7 +437,7 @@ void linearSystemCSR<std::complex<double> >::getMatrix(INDEX_TYPE *&jptr,
 #if defined(HAVE_GMM)
 
 #undef BB // can be defined by FlGui.h, and clashes with gmm arg name
-#include <gmm.h>
+#include "gmm.h"
 
 template <> int linearSystemCSRGmm<double>::systemSolve()
 {
diff --git a/src/solver/linearSystemGmm.h b/src/solver/linearSystemGmm.h
index a2a3496f12..98358bbd80 100644
--- a/src/solver/linearSystemGmm.h
+++ b/src/solver/linearSystemGmm.h
@@ -14,7 +14,7 @@
 #if defined(HAVE_GMM)
 
 #undef BB // can be defined by FlGui.h, and clashes with gmm arg name
-#include <gmm.h>
+#include "gmm.h"
 
 // Consider using linearSystemCSRGmm instead: assembly is much faster
 template <class scalar> class linearSystemGmm : public linearSystem<scalar> {
-- 
GitLab

